var through2 = require('through2');
var util = require('gulp-util');
var File = util.File;
var path = require('path');
var fs = require('fs');

module.exports = function(opts){
    var opts = opts || {};
    var optsVars = opts.vars || {};

    return through2.obj(function (file, enc, callback) {
        var importContent = {};
        var vars = {};

        // 获取文件所在目录
        var dirname = path.dirname(file.path);
        var content = String(file.contents)
            // include 替换
            .replace(/<%\@\s*include\s+file="(.*?)"\s*%>/g, function(str, $1){
                var filePath = path.resolve(dirname, $1);
                var key = filePath.replace(path.resolve(process.cwd(), opts.baseDir || 'src/jsp'), '').replace(/(^\\)|(\.jsp$)/g, '');
                var includeContent = '';

                if(!importContent[key]){
                    try{
                        includeContent = fs.readFileSync(filePath);
                    }catch(e){
                        console.log('地址：' + file.path + '\n' + e);
                    }
                    importContent[key] = includeContent;
                }

                return importContent[key];
            })

            // 变量抽取
            .replace(/String\s(.+)=\s*"(.+)";*/g, function(str, $1, $2){
                vars[$1.trim()] = $2;
            })

            // 变量替换 | 删除多余字符 | .jsp后缀替换
            .replace(/<%([\s\S]*?)%>|(\.jsp)/g, function(str, $1, $2){
                if($2){
                    return '.html';
                }else if($1.charAt(0) === '='){
                    var key = $1.substring(1).trim();

                    return optsVars[key] || vars[key];
                    // return 'http://localhost:3001';
                }else{
                    return '';
                }
            });

        var fileName = file.relative.replace(/\.jsp$/, '.html');
        var newFile = new File({
            path: fileName,
            contents: new Buffer(content)
        });

        this.push(newFile);

        callback();
    });
}